import logging

from spread_core.bam.engineries import shade
from spread_core.mqtt.spread.variable import Variable
from .subginery import Subginery, _SubgineriesFunit


class Shading(Subginery):
    pass


class _ShadingFunit(_SubgineriesFunit):
    entity_type = Shading
    target_class = shade.Shade

    def set(self):
        for e in self.entity.engineries.values():
            if isinstance(e, self.target_class):
                try:
                    self.target_command(e, Variable(self.set_value)).set()
                except BaseException as ex:
                    logging.debug(ex)


Shading.funit_class = _ShadingFunit


class Motion(_ShadingFunit):
    target_command = shade.Motion


class PositionLevel(_ShadingFunit):
    target_command = shade.PositionLevel


class Rotation(_ShadingFunit):
    target_command = shade.Rotation


class RotateAngle(_ShadingFunit):
    target_command = shade.RotateAngle


Shading.settable_units = [
    Motion,
    PositionLevel,
    Rotation,
    RotateAngle
]
