from django.core.management.base import BaseCommand


class Command(BaseCommand):
    help = 'Updates database from local files'

    def add_arguments(self, parser):
        parser.add_argument('--all', action='store_true', help='Does need fill all data')
        parser.add_argument('-c', '--ctp', action='store_true', help='Does need fill a project data')
        parser.add_argument('-t', '--tasks', action='store_true', help='Does need fill a scheduler dump')
        parser.add_argument('-cal', '--calendar', action='store_true', help='Does need fill a calendar dump')

    def handle(self, *args, **options):
        if options.get('ctp') or options.get('all'):
            from spread_dashboard.project.bam import Project
            try:
                Project.read_ctp()
            except BaseException:
                print('error ctp filling')
            else:
                print('ctp filling success')

        if options.get('calendar') or options.get('all'):
            from spread_dashboard.scheduler.models import Holiday
            try:
                Holiday.fill()
            except BaseException:
                print('error calendar filling')
            else:
                print('calendar filling success')

        if options.get('tasks') or options.get('all'):
            from spread_dashboard.scheduler.models import SchBase
            try:
                SchBase.fill()
            except BaseException:
                print('error tasks filling')
            else:
                print('tasks filling success')
